function StockFeedYahoo(){
	this.url = "http://finance.yahoo.com/d/quotes.csv?f=k1c6poghjkj4";
	this.delay = (5 * 1000 * 60);
	this.lastupdate = -1;
	this.stocks = new Array();
	
	this.request;
	this.input;
	this.rdfFile;
	this.raw;
	this.loaded = false;
	this.loadListener;
	this.timer 	= null;
	this.notifier;
	
	/**
	* Load all the Feeds
	*/
	this.load = function(){
		
		try{
			
			// Get update delay time
			var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			if(pref.prefHasUserValue("stockticker.update")){
				this.delay = pref.getIntPref("stockticker.update");
			}
			
			// Set pref listener
			var prefInternal = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
				prefInternal.addObserver("stockticker.update", this, false);
			
			// Init Notifier
			if(typeof(this.notifier) == 'undefined'){
				this.notifier = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
			}
			
			// Doesn't need to reload
			if(this.loaded && (new Date()).getTime() < (this.lastupdate + this.delay)){	
				this.notifier.notifyObservers(null, "stockticker_feed_loaded", this.stocks.length);
				return;
			}
			
			if(this.timer && this.timer.close){
				this.timer.close();
			}
			
			this.loaded = false;
			
			// Get RDF Path
			if(this.rdfFile == null){
				var props	= Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
				var uchrm	= (props.get("UChrm", Components.interfaces.nsIFile));
					uchrm.append("stockticker.rdf");
				this.rdfFile = uchrm.path;
			}
			
			// Create RDF File if it does not exist
			var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);	
				file.initWithPath(this.rdfFile);	
			if(!file.exists()){
				// Read RDF
				var oRequest	= Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
					oRequest.open("GET", "chrome://stockticker/content/stockticker.rdf", false);
		        	oRequest.send("");
				var sContent	= oRequest.responseText;
				
				// Write
				file.create(0x00, 0666);
				var fileOut = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
					fileOut.init(file, 0x20 | 0x02, 00666, null);
					fileOut.write(sContent, sContent.length);
					fileOut.flush();
					fileOut.close();
			}
			
			// Get Stock Symbols
			var oRdf 		= Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
			var oDs			= oRdf.GetDataSourceBlocking("file:///"+ this.rdfFile);
			var oRdfUtil	= Components.classes["@mozilla.org/rdf/container-utils;1"].getService(Components.interfaces.nsIRDFContainerUtils);
			var oRdfC 		= Components.classes["@mozilla.org/rdf/container;1"].createInstance(Components.interfaces.nsIRDFContainer);
		
			//Get Sequence
			if(oRdfUtil.IsSeq(oDs, oRdf.GetResource("http://jgillick.nettripper.com/stockticker"))){
				oRdfC.Init(oDs, oRdf.GetResource("http://jgillick.nettripper.com/stockticker")); 
			}
			else{
				return false;
			}
			
			// Loop Through Symbols
			this.stocks = new Array();
			var list = "";
			var aElements = oRdfC.GetElements();
			while(aElements.hasMoreElements()){
				try{
					var oRes = aElements.getNext();
						oRes = oRes.QueryInterface(Components.interfaces.nsIRDFResource);
					
					var oSymbol		= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#symbol"), true);
					var oName		= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#name"), true);
					var oNum		= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#number"), true);
					var oPrice		= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#price"), true);
					var oUrl		= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#url"), true);
					var oUrlDefault	= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#urlDefault"), true);
					var oFormat		= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#format"), true);
					var oFormatDef	= oDs.GetTarget(oRes, oRdf.GetResource("http://jgillick.nettripper.com/stockticker/rdf#formatDefault"), true);
					
					var oStock = Components.classes["@mozmonkey.com/stockticker/symbol;1"].createInstance(Components.interfaces.nsIStockSymbol);
					
					// Name
					if(oName instanceof Components.interfaces.nsIRDFLiteral){
						oStock.name = oName.Value;
					}
					
					// Shares
					if(oNum instanceof Components.interfaces.nsIRDFLiteral && !isNaN(oNum.Value)){
						oStock.shares = parseInt(oNum.Value);
					}
					
					// Price
					if(oPrice instanceof Components.interfaces.nsIRDFLiteral && !isNaN(oPrice.Value)){
						oStock.strike = parseFloat(oPrice.Value);
					}
					
					// Url
					if(oUrl instanceof Components.interfaces.nsIRDFLiteral
							&& oUrlDefault instanceof Components.interfaces.nsIRDFLiteral 
							&& oUrlDefault.Value.toUpperCase() == "FALSE"){
						oStock.url = oUrl.Value;
					}
					else{
						oStock.url = null;
					}
					
					// Format
					if(oFormat instanceof Components.interfaces.nsIRDFLiteral
							&& oFormatDef instanceof Components.interfaces.nsIRDFLiteral
							&& oFormatDef.Value.toUpperCase() == "FALSE"){
						oStock.format = oFormat.Value;
					}
					else{
						oStock.format = null;
					}
					
					// Symbol
					if(oSymbol instanceof Components.interfaces.nsIRDFLiteral){
						oStock.symbol = oSymbol.Value;
						this.stocks[this.stocks.length] = oStock;
						list += oStock.symbol +",";
					}
					
				} catch(e) { }
			}
			
			// Send Request
			if(this.stocks.length > 0){
				
				if(this.request != null){
					this.request.cancel(null);
				}
				
				var io			= Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var uri			= Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
					uri.spec	= this.url + "&s="+ list;
				this.request	= io.newChannelFromURI(uri).QueryInterface(Components.interfaces.nsIHttpChannel);
				this.request.asyncOpen(this, null);
			}
			
		}catch(e){
			throw e;
		}
	}
	
	/**
	* Reload the stock data
	*/
	this.update = function(){
		this.lastupdate = -1;
		this.loaded = false;
		this.load();
	}
	
	/**
	* Async Request Listener
	*/
	this.onStartRequest = function(request, ctxt) { }
	this.onDataAvailable = function(request, ctxt, input, offset, count) {
		try{
			this.input = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
			this.input.init(input);
		}catch(e){  }
	}
	this.onStopRequest = function(request, ctxt, status) {
		if(this.input == null){
			this.notifier.notifyObservers(null, "stockticker_feed_error", "Unable to retrieve feed");
		}
		try{
			this.raw = this.input.read(this.input.available())
			
			// Parse All Lines
			if(this.raw != null && this.raw != ""){
				var lines = this.raw.split("\n");
				
				for(var i = 0; i < lines.length; i++){
						
					if(lines[i] != null && lines[i] != ""){
						var fields = lines[i].split(",");
						
						if(fields.length < 9 || typeof(this.stocks[i]) == 'undefined') {
							continue;
						}
						
						
						this.stocks[i].trade		= fields[0].replace(/^\"|\"$/g, "");
						this.stocks[i].change 		= fields[1].replace(/^\"|\"$/g, "");
						this.stocks[i].prevClose 	= fields[2].replace(/^\"|\"$/g, "");
						this.stocks[i].open 		= fields[3].replace(/^\"|\"$/g, "");
						this.stocks[i].dayLow 		= fields[4].replace(/^\"|\"$/g, "");
						this.stocks[i].dayHigh 		= fields[5].replace(/^\"|\"$/g, "");
						this.stocks[i].yearLow 		= fields[6].replace(/^\"|\"$/g, "");
						this.stocks[i].yearHigh		= fields[7].replace(/^\"|\"$/g, "");
						this.stocks[i].ebitda 		= fields[8].replace(/^\"|\"$/g, "");
						this.stocks[i].lastupdate	= (new Date()).getTime();
												
						// Clean up crap
						this.stocks[i].trade = this.stocks[i].trade.replace(new RegExp("<[^>]*>", "g"), ""); // HTML 
						var aPrice = this.stocks[i].trade.split("-");
						if(aPrice.length > 1){
							this.stocks[i].trade = aPrice[1];
						}
						
						// Calculate Percent
						this.stocks[i].changePercent = ((Math.abs(parseFloat(this.stocks[i].change)) / parseFloat(this.stocks[i].prevClose)) * 100).toFixed(2);
						
						// Calculate Portfolio
						this.stocks[i].portfolio = ((parseFloat(this.stocks[i].trade) - this.stocks[i].strike) * this.stocks[i].shares);
					}
				}
					
			}	
			
			this.lastupdate = (new Date()).getTime();
			
			
			// Notify observer
			this.notifier.notifyObservers(null, "stockticker_feed_loaded", this.stocks.length);
			
			// Set update timer
			if(this.timer == null){
				this.timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
			}
			this.timer.initWithCallback(this, this.delay, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
			
		}catch(e){ 			
			this.notifier.notifyObservers(null, "stockticker_feed_error", e);
		}
		
		this.loaded = true;
	}
	
	/**
	* Timer done
	*/
	this.notify = function(timer){
		this.update();
	}

	
	/**
	* Observe preference changes
	*/
	this.observe = function(subject, topic, data){
		// Update time change
		if(topic == "stockticker.update"){
			var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			if(pref.prefHasUserValue("stockticker.update")){
				this.delay = pref.getIntPref("stockticker.update");
				this.load();
			}
		}
	}
	
	/**
	* Return array of stock feeds
	* @param array count An empty array
	*/
	this.getStocks = function(count){
		count.value = this.stocks.length;
		return this.stocks;
	}
	
	/**
	* Output's debug statments
	* @param string msg Debug message
	*/
	this.debug = function(msg){
		return;
	
		if(typeof(Components.classes["@mozmonkey.com/debuglogger/manager;1"]) != 'undefined'){
			var logMngr = Components.classes["@mozmonkey.com/debuglogger/manager;1"].getService(Components.interfaces.nsIDebugLoggerManager);
			logMngr.registerLogger("stockticker").log(3, msg);
		}
	}
}

StockFeedYahoo.prototype = {

	QueryInterface: function (iid) {
		if(!iid.equals(Components.interfaces.nsIStockFeed) && !iid.equals(Components.interfaces.nsISupports))
			throw Components.results.NS_ERROR_NO_INTERFACE;
		
		return this;
	}
};
var Module = {
	myCID : Components.ID("{BCFCEF8D-FB20-47cb-A324-C93A7F69A9F5}"),
    myProgID : "@mozmonkey.com/stockticker/feed/yahoo;1",
    firstTime : true,
	registerSelf : function (compMgr, fileSpec, location, type) {
		if(this.firstTime) {
			this.firstTime = false;
			throw Components.results.NS_ERROR_FACTORY_REGISTER_AGAIN;
		}
		compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
		compMgr.registerFactoryLocation(this.myCID, "StockTicker Yahoo! Feed", this.myProgID, fileSpec, location, type);
	},
	getClassObject : function (compMgr, cid, iid) {
		if (!cid.equals(this.myCID)) throw Components.results.NS_ERROR_NO_INTERFACE;
		if (!iid.equals(Components.interfaces.nsIFactory)) throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
		return this.myFactory;
	},
    myFactory : {
		createInstance : function (outer, iid) {
			if (outer != null) throw Components.results.NS_ERROR_NO_AGGREGATION;
			return (new StockFeedYahoo()).QueryInterface(iid);
		}
	},
    canUnload : function(compMgr) { return true; }
};
function NSGetModule(compMgr, fileSpec) { return Module; }