
const gName			= "StockTicker";
const gAuthor		= "Jeremy Gillick";
const gRegKey		= "/JeremyGillick/StockTicker";
const gVersion		= "1.0.4";
const gJar			= "stockticker.jar";

var	error 			= null;
var oFolder			= getFolder("Current User", "chrome");
var iContentFlag	= CONTENT | PROFILE_CHROME;

// Install in App or Profile directory?
var existsInApplication = File.exists(getFolder(getFolder("chrome"), gJar));
var existsInProfile     = File.exists(getFolder(oFolder, gJar));
if(existsInApplication || (!existsInProfile && !confirm("Do you want to install the extension into your profile folder?\n(Cancel will install into the application folder)")))
{
    iContentFlag = CONTENT | DELAYED_CHROME;
    oFolder      = getFolder("chrome");
}

// Uninstall Current
if(existsInApplication || existsInProfile)
	uninstall(gRegKey);

// Init
initInstall(gName, gRegKey, gVersion);
setPackageFolder(oFolder);

// Add components
addFile(gAuthor, gVersion, "components/nsStockSymbol.xpt", getFolder("Components"), "nsStockSymbol.xpt", true);
addFile(gAuthor, gVersion, "components/nsStockSymbol.js", getFolder("Components"), "nsStockSymbol.js", true);
addFile(gAuthor, gVersion, "components/StockFeed.xpt", getFolder("Components"), "StockFeed.xpt", true);
addFile(gAuthor, gVersion, "components/StockFeedYahoo.js", getFolder("Components"), "StockFeedYahoo.js", true);

// Add chrome
addFile(gAuthor, gVersion, "chrome/"+ gJar, oFolder, null);

// Register and install
registerChrome(iContentFlag, getFolder(oFolder, gJar), "content/");
performInstall();
